package com.sa.ibiz.demo.demo.service.dto;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.ibizutil.domain.ParentData;
import com.sa.ibiz.demo.demo.domain.WFAppSetting;
import org.springframework.util.StringUtils;
import lombok.Data;
import java.util.Map;
import java.sql.Timestamp;
import com.sa.ibiz.demo.ibizutil.service.SearchFilterBase;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.sa.ibiz.demo.ibizutil.helper.DataGridCustomSearchHelper;
import com.alibaba.fastjson.JSONObject;
@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class WFAppSettingSearchFilter extends SearchFilterBase {

	private String query;
	private Page page;
	private QueryWrapper<WFAppSetting> selectCond;
	private JSONObject customsearchval;
	public WFAppSettingSearchFilter(){
		this.page =new Page<WFAppSetting>(1,Short.MAX_VALUE);
		this.selectCond=new QueryWrapper<WFAppSetting>();	
	}

	/**
	 * 设定自定义查询条件，在原有SQL基础上追加该SQL
	 */
	public void setCustomCond(String sql)
	{
		this.selectCond.apply(sql);
	}

	private String n_remindmsgtempid_eq;

	public void setN_remindmsgtempid_eq(String n_remindmsgtempid_eq) {
        this.n_remindmsgtempid_eq = n_remindmsgtempid_eq;
        if(!StringUtils.isEmpty(this.n_remindmsgtempid_eq)){
            this.selectCond.eq("remindmsgtempid", n_remindmsgtempid_eq);
        }
    }
	private String n_remindmsgtemplname_eq;

	public void setN_remindmsgtemplname_eq(String n_remindmsgtemplname_eq) {
        this.n_remindmsgtemplname_eq = n_remindmsgtemplname_eq;
        if(!StringUtils.isEmpty(this.n_remindmsgtemplname_eq)){
            this.selectCond.eq("remindmsgtemplname", n_remindmsgtemplname_eq);
        }
    }
	private String n_remindmsgtemplname_like;

	public void setN_remindmsgtemplname_like(String n_remindmsgtemplname_like) {
        this.n_remindmsgtemplname_like = n_remindmsgtemplname_like;
        if(!StringUtils.isEmpty(this.n_remindmsgtemplname_like)){
            this.selectCond.like("remindmsgtemplname", n_remindmsgtemplname_like);
        }
    }
	private String n_wfappsettingname_like;

	public void setN_wfappsettingname_like(String n_wfappsettingname_like) {
        this.n_wfappsettingname_like = n_wfappsettingname_like;
        if(!StringUtils.isEmpty(this.n_wfappsettingname_like)){
            this.selectCond.like("wfappsettingname", n_wfappsettingname_like);
        }
    }

	public void setSrfparentdata(Map<String, String> srfparentdata) {
		this.srfparentdata = srfparentdata;
		String strParentkey=this.getSrfparentdata().get("srfparentkey");
		if(this.srfparentdata.containsKey("srfparentmode")&& this.getSrfparentdata().get("srfparentmode").equals("DER1N_WFAPPSETTING_MSGTEMPLATE_REMINDMSGTEMPID"))
			if(StringUtils.isEmpty(strParentkey)){
				this.setN_remindmsgtempid_eq("NA");
			}
			else{
				this.setN_remindmsgtempid_eq(strParentkey);
			}
	}

	/**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
			this.selectCond.or().like("wfappsettingname",query);
		 }
	}

	/**
	 * 自定义查询
	 * @param customsearchval
	 */
	public void setCustomsearchval(JSONObject customsearchval) {
		this.customsearchval = customsearchval;
		if(!StringUtils.isEmpty(customsearchval)){
			DataGridCustomSearchHelper customSearchHelper= DataGridCustomSearchHelper.getInstance();
			String customSql =customSearchHelper.parseCustomVal(customsearchval);
			this.selectCond.apply(customSql);
		}
	}

}